urshd — micro remote shell server
=================================

urshd is a minimal rsh server intended to give shell access for running remote
tests on constrained devices. It is built with only the minimal necessary
features in mind, even without security. It is not intended to be used on
production systems.

Installation and Usage
----------------------

`./configure && make` will build `src/urshd`, which you can then distribute to
wherever you need it, it has no external dependencies.

`./configure --enable-debug && make` will build a debugging version.

To start the server, simply do a `urshd` and it will fork into the background.
See `urshd --help` for more options.

Bugs
----

Yes. The main focus of this program is testing embedded devices, so most
security features are left out. Simply put, urshd is a monumental security hole.
Never ever use it on production systems.

For everything else, report bugs to <bugs@pengutronix.de>.

License
-------

urshd is based on the BSD rshd, and licensed under the BSD 4-clause license:

    Copyright (c) 1988, 1989 The Regents of the University of California.
    All rights reserved.
    Copyright (c) 2008, 2017 Pengutronix e.K.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

    3. All advertising materials mentioning features or use of this software
       must display the following acknowledgement:

           This product includes software developed by the University of
           California, Berkeley, Pengutronix e.K., and their contributors.

    4. Neither the name of the the copyright holders nor the names of their
       contributors may be used to endorse or promote products derived from this
       software without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
    TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
    OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
    OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
    ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
